/*
 * MISSING.H -- a support library for NEWS-OS 4.x, header file
 *
 * written by matusita@ics.es.osaka-u.ac.jp
 */

#ifndef _MISSING_H_
#define _MISSING_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*
 * including...
 */
#include <sys/types.h>
#include <time.h>

/*
 * type definition
 */
typedef long		clock_t;
typedef long		fpos_t;
typedef unsigned short	mode_t;
typedef int		pid_t;
typedef int		sigjmp_buf[33];
typedef unsigned int	sigset_t;

struct sigaction {
	int		(*sa_handler)();	/* signal handler */
	sigset_t	sa_mask;
	int		sa_flags;
};

#if 1
#define SYS_NMLN	257		/* 4.0 size of utsname elements.*/
#else
#define SYS_NMLN	9		/* old size of utsname elements */
#endif

struct utsname {
	char	sysname[SYS_NMLN];	/* Name of this OS. */
	char	nodename[SYS_NMLN];	/* Name of this network node. */
	char	release[SYS_NMLN];	/* Release level. */
	char	version[SYS_NMLN];	/* Version level. */
	char	machine[SYS_NMLN];	/* Hardware type. */
};

/*
 * constat define
 */
#ifndef const
#ifndef __STDC__
#define const
#endif /* !defined __STDC__ */
#endif /* !defined const */

/*
 * constant define
 */
/* cuserid() uses this value for length of username (including \0) */
#ifndef L_cuserid
#define L_cuserid	9
#endif /* L_cuserid */
/* clock() uses this value for CLOCKS_PER_SEC's of a second */
#define	CLOCKS_PER_SEC	60
/* sigprocmask() uses these value for how to act */
#define SIG_BLOCK	1
#define SIG_UNBLOCK	2
#define SIG_SETMASK	3
/* sigaction() uses SA_NOCLDSTOP, but NEWS-OS does not implement it */

/*
 * function prototypes
 */
#ifndef __P
#if defined(__STDC__) || defined(__cplusplus)
#define __P(protos)	protos		/* full-blown ANSI C */
#else
#define __P(protos)	()		/* traditional C preprocessor */
#endif
#endif

clock_t clock __P((void));
char * cuserid __P((char *));
double drand48 __P((void));
double erand48 __P((unsigned short[3]));
double fmod __P((double, double));
long jrand48 __P((unsigned short[3]));
void lcong48 __P((unsigned short[7]));
long lrand48 __P((void));
int mkfifo __P((const char *, mode_t));
time_t mktime __P((register struct tm *));
long mrand48 __P((void));
long nrand48 __P((unsigned short[3]));
unsigned short *seed48 __P((unsigned short[3]));
int setsid __P((void));
int sigaction __P((int, const struct sigaction *, struct sigaction *));
int sigaddset __P((sigset_t *, int));
int sigdelset __P((sigset_t *, int));
int sigemptyset __P((sigset_t *));
int sigfillset __P((sigset_t *));
int sigismember __P((const sigset_t *, int));
int sigsetjmp __P((sigjmp_buf, int));
void siglongjmp __P((sigjmp_buf, int));
void srand48 __P((long));
size_t strftime __P((char *, size_t, const char *, const struct tm *));
pid_t waitpid __P((pid_t, int *, int));
int uname __P((struct utsname *));

#include <sys/newsos.h>
#if (NEWSOS_MINOR < 2)
void *memmove __P((void *, const void *, size_t));
int strcmp __P((const char *, const char *));
char *strdup __P((const char *));
char *strstr __P((const char *, const char *));
char *strtok __P((char *, const char *));
#endif /* NEWSOS_MINOR < 2 */

#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* _MISSING_H_ */
